accounting/apps/people/urls.py
from django.conf.urls import patterns, url

from . import views


urlpatterns = patterns('',

    # Clients
    url(r'^client/$',
        views.ClientListView.as_view(),
        name="client-list"),
    url(r'^client/create/$',
        views.ClientCreateView.as_view(),
        name="client-create"),
    url(r'^client/(?P<pk>\d+)/edit/$',
        views.ClientUpdateView.as_view(),
        name="client-edit"),
    url(r'^client/(?P<pk>\d+)/detail/$',
        views.ClientDetailView.as_view(),
        name="client-detail"),

    # Employees
    url(r'^employee/$',
        views.EmployeeListView.as_view(),
        name="employee-list"),
    url(r'^employee/create/$',
        views.EmployeeCreateView.as_view(),
        name="employee-create"),
    url(r'^employee/(?P<pk>\d+)/edit/$',
        views.EmployeeUpdateView.as_view(),
        name="employee-edit"),
    url(r'^employee/(?P<pk>\d+)/detail/$',
        views.EmployeeDetailView.as_view(),
        name="employee-detail"),
)

accounting/urls.py
from django.conf import settings
from django.conf.urls import patterns, include, url
from django.conf.urls.static import static


urlpatterns = patterns('',
    url(r'^', include('accounting.apps.connect.urls',
        namespace="connect")),
    url(r'^books/', include('accounting.apps.books.urls',
        namespace="books")),
    url(r'^people/', include('accounting.apps.people.urls',
        namespace="people")),
    url(r'^reports/', include('accounting.apps.reports.urls',
        namespace="reports")),

    # third party
    url(r'^select2/', include('django_select2.urls')),
)

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL,
                          document_root=settings.MEDIA_ROOT)

accounting/apps/people/models.py
from decimal import Decimal as D

from django.db import models
from django.core.validators import MinValueValidator, MaxValueValidator


class Client(models.Model):
    name = models.CharField(max_length=150)

    # address
    address_line_1 = models.CharField(max_length=128)
    address_line_2 = models.CharField(max_length=128,
                                      blank=True, null=True)
    city = models.CharField(max_length=64)
    postal_code = models.CharField(max_length=7)
    country = models.CharField(max_length=50)

    organization = models.ForeignKey('books.Organization',
                                     related_name="clients")

    class Meta:
        pass

    def __str__(self):
        return self.name

    def active_address_fields(self):
        """
        Return the non-empty components of the address
        """
        fields = [self.address_line_1, self.address_line_2,
                  self.city, self.postal_code, self.country]
        fields = [f.strip() for f in fields if f]
        return fields

    def full_address(self, separator="\n"):
        return separator.join(filter(bool, self.active_address_fields()))


class Employee(models.Model):
    first_name = models.CharField(max_length=150)
    last_name = models.CharField(max_length=150)
    email = models.EmailField(max_length=254)

    payroll_tax_rate = models.DecimalField(
        max_digits=6,
        decimal_places=5,
        validators=[
            MinValueValidator(D('0')),
            MaxValueValidator(D('1'))
        ]
    )

    salary_follows_profits = models.BooleanField(default=False)
    shares_percentage = models.DecimalField(
        max_digits=6,
        decimal_places=5,
        validators=[
            MinValueValidator(D('0')),
            MaxValueValidator(D('1'))
        ]
    )

    organization = models.ForeignKey('books.Organization',
                                     related_name="employees")

    class Meta:
        pass

    def __str__(self):
        return "{}".format(self.composite_name)

    @property
    def composite_name(self):
        return "{} {}".format(self.first_name, self.last_name)

accounting/apps/people/forms.py
from django.forms import ModelForm
from django.contrib.auth import get_user_model

from .models import Client, Employee

from django_select2.fields import (
    AutoModelSelect2Field,
    AutoModelSelect2MultipleField)


class ClientForm(ModelForm):
    class Meta:
        model = Client
        fields = (
            "name",
            "address_line_1",
            "address_line_2",
            "city",
            "postal_code",
            "country",
        )


class EmployeeForm(ModelForm):
    class Meta:
        model = Employee
        fields = (
            "first_name",
            "last_name",
            "email",

            "payroll_tax_rate",

            "salary_follows_profits",
            "shares_percentage",

        )


# TODO: avoid calling this in the global scope, can lead to circular imports
User = get_user_model()


class UserChoices(AutoModelSelect2Field):
    queryset = User.objects.all()
    search_fields = (
        'first_name__icontains',
        'last_name__icontains',
        'username__icontains',
        'email__icontains',
    )


class UserMultipleChoices(AutoModelSelect2MultipleField):
    queryset = User.objects.all()
    search_fields = (
        'first_name__icontains',
        'last_name__icontains',
        'username__icontains',
        'email__icontains',
    )

accounting/apps/people/views.py
from django.views import generic
from django.core.urlresolvers import reverse

from accounting.apps.books.mixins import (
    RestrictToSelectedOrganizationQuerySetMixin,
    AutoSetSelectedOrganizationMixin)
from .models import Client, Employee
from .forms import ClientForm, EmployeeForm


class ClientListView(RestrictToSelectedOrganizationQuerySetMixin,
                     generic.ListView):
    template_name = "people/client_list.html"
    model = Client
    context_object_name = "clients"


class ClientCreateView(AutoSetSelectedOrganizationMixin,
                       generic.CreateView):
    template_name = "people/client_create_or_update.html"
    model = Client
    form_class = ClientForm

    def get_success_url(self):
        return reverse("people:client-list")


class ClientUpdateView(RestrictToSelectedOrganizationQuerySetMixin,
                       AutoSetSelectedOrganizationMixin,
                       generic.UpdateView):
    template_name = "people/client_create_or_update.html"
    model = Client
    form_class = ClientForm

    def get_success_url(self):
        return reverse("people:client-list")


class ClientDetailView(RestrictToSelectedOrganizationQuerySetMixin,
                       generic.DetailView):
    template_name = "people/client_detail.html"
    model = Client
    context_object_name = "client"


class EmployeeListView(RestrictToSelectedOrganizationQuerySetMixin,
                       generic.ListView):
    template_name = "people/employee_list.html"
    model = Employee
    context_object_name = "employees"


class EmployeeCreateView(AutoSetSelectedOrganizationMixin,
                         generic.CreateView):
    template_name = "people/employee_create_or_update.html"
    model = Employee
    form_class = EmployeeForm

    def get_success_url(self):
        return reverse("people:employee-list")


class EmployeeUpdateView(RestrictToSelectedOrganizationQuerySetMixin,
                         AutoSetSelectedOrganizationMixin,
                         generic.UpdateView):
    template_name = "people/employee_create_or_update.html"
    model = Employee
    form_class = EmployeeForm

    def get_success_url(self):
        return reverse("people:employee-list")


class EmployeeDetailView(RestrictToSelectedOrganizationQuerySetMixin,
                         generic.DetailView):
    template_name = "people/employee_detail.html"
    model = Employee
    context_object_name = "employee"

accounting/templates/accounting/people/client_create_or_update.html
{% extends "_generics/form.html" %}

accounting/templates/accounting/people/client_list.html
{% extends "accounting/layout.html" %}

{% block content %}
    <h1 class="page-header">Clients <small>which belong to you</small></h1>

    <table class="table table-striped">
        <thead>
            <tr>
                <th>#</th>
                <th>Name</th>
                <th class="text-right">Actions</th>
            </tr>
        </thead>
        <tbody>
            {% for cli in clients %}
            <tr>
                <td>{{ cli.id }}</td>
                <td>{{ cli.name }}</td>
                <td class="text-right">
                    <a href="{% url 'people:client-edit' cli.pk %}" class="btn btn-default btn-sm" role="button">Edit</a>
                </td>
            </tr>
            {% endfor %}
        </tbody>
    </table>

    <a href="{% url 'people:client-create' %}" class="btn btn-primary btn-lg" role="button">
        Add a client
    </a>
{% endblock content %}

accounting/templates/accounting/people/employee_create_or_update.html
{% extends "_generics/form.html" %}

accounting/templates/accounting/people/employee_list.html
{% extends "accounting/layout.html" %}

{% block content %}
    <h1 class="page-header">Employees <small>which belong to you</small></h1>

    <table class="table table-striped">
        <thead>
            <tr>
                <th>#</th>
                <th>First name</th>
                <th>Last name</th>
                <th>Email</th>
                <th class="text-right">Actions</th>
            </tr>
        </thead>
        <tbody>
            {% for emp in employees %}
            <tr>
                <td>{{ emp.id }}</td>
                <td>{{ emp.first_name }}</td>
                <td>{{ emp.last_name }}</td>
                <td>{{ emp.email }}</td>
                <td class="text-right">
                    <a href="{% url 'people:employee-edit' emp.pk %}" class="btn btn-default btn-sm" role="button">Edit</a>
                </td>
            </tr>
            {% endfor %}
        </tbody>
    </table>

    <a href="{% url 'people:employee-create' %}" class="btn btn-primary btn-lg" role="button">
        Add an employee
    </a>
{% endblock content %}